/*
 * ao.c - Milena Audiobook Creator
 * Copyright (C) Bohdan R. Rau 2009 <ethanak@polip.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write see:
 *               <http://www.gnu.org/licenses/>.
 */
#include <ao/ao.h>

static int ao_playing;

static ao_device *device;
static int driver=-1;
static ao_sample_format format;
static int ao_initialized;
int dont_close_audiodevice;
static int init_ao(void)
{
	ao_info *info;
	format.bits = 16;
	format.channels = 1;
	format.rate = 16000;
	format.byte_format = AO_FMT_LITTLE;
	
	if (!ao_initialized) ao_initialize();
	if (driver == -1) {
		/*driver=ao_driver_id("pulse");
		if (driver ==  -1)*/
		driver = ao_default_driver_id();
		if (driver == -1) {
			//MessageBox(NULL,"Brak domylnego drivera LibAO",NULL,MB_OK | MB_ICONERROR);
			return 0;
		}
//		info=ao_driver_info(driver);
//		printf("Info=%p\n",info);
//		if (info) {
//			printf("Name: %s\nShort: %s\n",info->name,info->short_name);
//		}
	}
	if (!device) device = ao_open_live(driver, &format, NULL);
	if (!device) {
		
		return 0;
	}
	return 1;
}

int audio_play(short *samples,int nsamples)
{
	if (!samples) {
		if (ao_playing) {
			if (!dont_close_audiodevice) {
				ao_close(device);
				device=NULL;
			}
			ao_playing=0;
		}
		return 1;
	}
	if (!ao_playing) {
		if (!init_ao()) return 0;
		ao_playing=1;
	}
	if (!ao_play(device,(char *)samples,2*nsamples)) {
		ao_close(device);
		device=NULL;
		ao_playing=0;
		return 0;
	}
	return 1;
}
