#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <epub.h>
#include "html.h"

append_xhtml(char *c,char **outb)
{
    int n=html2txt(c,NULL);
    char *s;
    if (n<=0) return;
    if (!*outb) {
        *outb=malloc(n+1);
        s=*outb;
    }
    else {
        *outb=realloc(*outb,strlen(*outb)+n);
        s=*outb+strlen(*outb);
    }
    html2txt(c,s);
}

char *read_epub(char *name,char **err)
{
    struct epub *epub;
    struct eiterator *it;
    char *outht=NULL;
    epub=epub_open(name, 0);
    if (!epub) {
        if (err) *err='Błąd otwarcia pliku ePub';
        epub_cleanup();
        return NULL;
    }
    //it=epub_get_iterator(epub, EITERATOR_SPINE, 0);
    it=epub_get_iterator(epub, EITERATOR_LINEAR, 0);
    do {
        char *c=epub_it_get_curr(it);
        if (c) append_xhtml(c,&outht);
    } while (epub_it_get_next(it));
    epub_free_iterator(it);
    epub_close(epub);
    if (!outht) {
        if (err) *err="Pusta treść ePub";
    }
    return outht;
}
