/*
 * mplayer.c - Milena Audiobook Creator
 * Copyright (C) Bohdan R. Rau 2010 <ethanak@polip.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write see:
 *               <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "gmilena.h"
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <samplerate.h>
#include <math.h>

char movie_name[PATH_MAX+1];
char movie_workdir[PATH_MAX+1];

extern GtkWidget *m_video_caud,*m_video_cmov;

double smix_speed=0.0;
double smix_maxspeed;
int smix_droptime=500,smix_risetime=3000,smix_mindist=3000;
int smix_audio_margin=400;
double smix_volume_factor=4.0;
double smix_max_origin_vol=1.0;

static void fine_mpla(void);

static int rt(void){
	return TRUE;
}

void enable_video_menues(int is_main,struct MyGtkEditor *editor)
{
		char buf[1024];
		int t1=0,t2=0;
		if (is_main<0) {
			is_main = (get_current_editor() == 0);
		}
		if (!editor) {
			editor=gimma_current_editor();
		}
		if (editor && movie_workdir[0]) {
			if (is_main) {
				int p=0;
				sprintf(buf,"%s/dumpsub.txt",movie_workdir);
				if (!strcmp(buf,editor->save_name) ||
					!strcmp(buf,editor->load_name)) {
						p=1;
				}
				if (!p) {
					sprintf(buf,"%s/dumpsub.jss",movie_workdir);
					if (!strcmp(buf,editor->save_name) ||
						!strcmp(buf,editor->load_name)) {
							p=1;
					}
				}
				if (p) {
					sprintf(buf,"%s/audiodump.wav",movie_workdir);
					if (g_file_test(buf,G_FILE_TEST_IS_REGULAR))t1=1;
				}
			}
			sprintf(buf,"%s/newaudio.wav",movie_workdir);
			if (g_file_test(buf,G_FILE_TEST_IS_REGULAR))t2=1;
		}
		gtk_widget_set_sensitive(m_video_caud,t1);
		gtk_widget_set_sensitive(m_video_cmov,t2);
		
}
void mplayer_read_movie(GtkWidget *widget,void *dummy)
{
	char *fname=NULL;
	char *subname=NULL;
	GtkFileFilter *filter;
	static int autosub=1;
	char buf[1024];
	int subonly = 1;
	struct stat sb;
	int dialog_pos=1;
	char *dialog_names[6];
	int dialog_ids[6];
	int n;
	char *subencos[]={NULL,"enca:pl:cp1250","cp1250","latin2"};
	static int subencnum=0;
	void erase_file(char *fn)
	{
		sprintf(buf,"%s/%s",movie_workdir,fn);
		unlink(buf);
	}

	GtkWidget *dialog=gtk_file_chooser_dialog_new(
		"Wybierz film",
		GTK_WINDOW(main_window),GTK_FILE_CHOOSER_ACTION_OPEN,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
		NULL);
	GtkWidget *autosub_cb=gtk_check_button_new_with_label("Automatycznie załaduj napisy");
	GtkWidget *onlysub_cb=gtk_check_button_new_with_label("Tylko napisy (bez tworzenia audio)");
	gtk_toggle_button_set_active((gpointer) autosub_cb,autosub);
	gtk_toggle_button_set_active((gpointer) onlysub_cb,0);
	GtkWidget *labelbox=gtk_hbox_new(0,2);
	GtkWidget *encombo=combo(subencnum,"Nie podawaj","Auto","CP-1250","ISO-8859-2",NULL);
	GtkWidget *lab=gtk_label_new("Kodowanie napisów");
	connect_label(lab,encombo);
	gtk_box_pack_start(GTK_BOX(labelbox),lab,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(labelbox),encombo,FALSE,FALSE,0);
	
	GtkWidget *hbox=gtk_vbox_new(0,2);
	gtk_box_pack_start(GTK_BOX(hbox),autosub_cb,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),onlysub_cb,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),labelbox,FALSE,FALSE,0);
	gtk_file_chooser_set_local_only((gpointer)dialog,TRUE);
	gtk_file_chooser_add_filter((gpointer) dialog,
		make_filter("Pliki video","*.avi","*.AVI","*.rmvb","*.RMVB",NULL));
	gtk_file_chooser_add_filter((gpointer) dialog,
		filter=make_filter("Wszystkie pliki","*",NULL));
	gtk_file_chooser_set_filter((gpointer) dialog,filter);
	gtk_file_chooser_set_extra_widget((gpointer) dialog,hbox);
	gtk_widget_show_all(hbox);
	if ((n=gtk_dialog_run((gpointer)dialog))==GTK_RESPONSE_ACCEPT){
		fname=gtk_file_chooser_get_filename((gpointer)dialog);
		autosub=gtk_toggle_button_get_active((gpointer)autosub_cb);
		subonly=gtk_toggle_button_get_active((gpointer)onlysub_cb);
		subencnum=gtk_combo_box_get_active((gpointer)encombo);
	}
	gtk_widget_destroy(dialog);
	if (!fname) {
		enable_video_menues(-1,NULL);
		return;
	}
	if (!autosub) {
		dialog=gtk_file_chooser_dialog_new(
			"Wybierz plik napisów",
			GTK_WINDOW(main_window),GTK_FILE_CHOOSER_ACTION_OPEN,
			GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
			GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
			NULL);
		gtk_file_chooser_set_local_only((gpointer)dialog,TRUE);
		gtk_file_chooser_add_filter((gpointer) dialog,
			make_filter("Pliki video","*.avi","*.AVI","*.rmvb","*.RMVB",NULL));
		gtk_file_chooser_add_filter((gpointer) dialog,
			filter=make_filter("Wszystkie pliki","*",NULL));
		gtk_file_chooser_set_filter((gpointer) dialog,filter);
		if (gtk_dialog_run((gpointer)dialog)==GTK_RESPONSE_ACCEPT){
			subname=gtk_file_chooser_get_filename((gpointer)dialog);
		}
		gtk_widget_destroy(dialog);
		if (!subname) {
			g_free(fname);
			enable_video_menues(-1,NULL);
			return;
		}

	}
	strcpy(movie_name,fname);
	g_free(fname);
	char *cs=strrchr(fname,'/');
	if (!cs) {
		if (subname) g_free(subname);
		enable_video_menues(-1,NULL);
		return;
	}
	cs++;
	
	char *ds=strrchr(cs,'.');
	if (ds && ds !=cs) n=ds-cs;
	else n=strlen(cs); 
	sprintf(movie_workdir,"%s/tmp/%-*.*s",getenv("HOME"),n,n,cs);

	n=g_mkdir_with_parents(movie_workdir,0700);
	if (n<0) {
perr:		if (subname) g_free(subname);
		sprintf(buf,"Błąd tworzenia katalogu roboczego:\n%s",strerror(errno));
		Error("Błąd",buf);
		enable_video_menues(-1,NULL);
		return;
	}
	int pid;
	int rc=subonly?1:3;
	int sub_exists=0;
	int wav_exists=0;
	

	sprintf(buf,"%s/dumpsub.jss",movie_workdir);
	if (g_file_test(buf,G_FILE_TEST_IS_REGULAR) && !stat(buf,&sb)) {
		time_t t1=sb.st_mtime,t2,t3;
		sub_exists=1;
		sprintf(buf,"%s/dumpsub.txt",movie_workdir);
		if (g_file_test(buf,G_FILE_TEST_IS_REGULAR) && !stat(buf,&sb)) {
			t2=sb.st_mtime;
			if (t2 >= t1) {
				sub_exists |= 2;
				sprintf(buf,"%s/dumpsub.dic",movie_workdir);
				if (g_file_test(buf,G_FILE_TEST_IS_REGULAR) && !stat(buf,&sb)) {
					//t3=sb.st_mtime;
					//if (t3 >= t2) {
						sub_exists |= 4;
					//}
				}
			}
		}
	}
	if (!subonly) {
		sprintf(buf,"%s/audiodump.wav",movie_workdir);
		if (g_file_test(buf,G_FILE_TEST_IS_REGULAR)) {
			wav_exists=1;
		}
	}
	dialog_names[0]="Anuluj";
	dialog_ids[0]=GTK_RESPONSE_CANCEL;

	void add_button(char *a,int b)
	{
		dialog_names[dialog_pos]=a;
		dialog_ids[dialog_pos++]=b;
		dialog_names[dialog_pos]=NULL;
	}
		
	
	if (sub_exists) {
		if (subonly) {
			add_button("Utwórz nowe",1);
			add_button("Istniejące",4);
		}
		else {
			if (wav_exists) {
				add_button("Utwórz nowe",3);
				add_button("Pozostaw napisy",2);
				add_button("Pozostaw audio",1);
				add_button("Istniejące",4);
			}
			else {
				add_button("Utwórz nowe",3);
				add_button("Utwórz tylko audio",2);
				add_button("Istniejące",4);
			}
		}
	}
	if (dialog_pos>1) {
		dialog=gtk_dialog_new_with_buttons("Pytanko",
			(gpointer)main_window,
			GTK_DIALOG_DESTROY_WITH_PARENT,
			dialog_names[0],dialog_ids[0],
			dialog_names[1],dialog_ids[1],
			dialog_names[2],dialog_ids[2],
			dialog_names[3],dialog_ids[3],
			dialog_names[4],dialog_ids[4],NULL);
		GtkWidget *label=gtk_label_new(
			(wav_exists && sub_exists) ?"Znaleziono istniejące pliki audio i napisów":
			wav_exists?"Znaleziono istniejący plik audio":
			"Znaleziono istniejący plik napisów");
		GtkWidget *ca=gtk_dialog_get_content_area (GTK_DIALOG (dialog));
		gtk_container_add (GTK_CONTAINER (ca), label);
		gtk_widget_show_all(dialog);
		rc=gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		if (rc < 1 || rc > 4) {
			enable_video_menues(-1,NULL);
			return;
		}
	}


	rc = rc & 3;
	if (rc) {
		char *envp[32];
		int vpos;
		envp[0]="mplayer";
		vpos=1;
		if (rc & 1) {
			if (subname) {
				envp[vpos++]="-sub";
				envp[vpos++]=subname;
			}
			envp[vpos++]="-dumpjacosub";
			if (subencnum) {
				envp[vpos++]="-subcp";
				envp[vpos++]=subencos[subencnum];
			}
		}
		if (rc == 1) {
			envp[vpos++]="-nosound";//"-ao";
			//envp[vpos++]="-novideo";
			envp[vpos++]="-vo";
			envp[vpos++]="none";
			//envp[vpos++]="-vc";
			//envp[vpos++]="null";
		}
		else {
			envp[vpos++]="-ao";
			envp[vpos++]="pcm:fast:waveheader";
			envp[vpos++]="-vo";
			envp[vpos++]="null";
			envp[vpos++]="-vc";
			envp[vpos++]="null";
		}
		envp[vpos++]=movie_name;
		envp[vpos]=NULL;
		pid=fork();
		if (pid < 0) {
			goto perr;
		}
		if (!pid) {
			chdir(movie_workdir);
			execvp(envp[0],envp);
			exit(0);
		}
		GtkWidget *progr=gtk_dialog_new_with_buttons(
		"Mplayer",
			(gpointer)main_window,
			GTK_DIALOG_MODAL,
			"Przerwij",100,
			NULL);


		int pbreak=0;

		int progbreak(GtkWidget *w,gint id,gpointer udata)
		{
			if (id == 100) pbreak=1;
		}
			
		g_signal_connect_swapped(G_OBJECT(progr), "delete-event",
			G_CALLBACK(rt), NULL);
		g_signal_connect_swapped(G_OBJECT(progr), "response",
			G_CALLBACK(progbreak), NULL);

		gtk_widget_show_all((gpointer)progr);
		int mplayer_status=0;
		for (;;) {
			if (waitpid(pid,&mplayer_status,WNOHANG)==pid) break;
			yield();
			if (pbreak) break;
		}
		gtk_widget_hide_all((gpointer)progr);
		gtk_widget_destroy(progr);
		if (pbreak) {
			kill(pid,9);
			waitpid(pid,NULL,0);
			if (rc & 1) {
				erase_file("dumpsub.jss");
			}
			if (rc & 2) {
				erase_file("audiodump.wav");
			}
			Info("Mplayer","Operacja anulowana");
			if (subname) {
				g_free(subname);
			}
			enable_video_menues(-1,NULL);	
			return;
		}
		if (mplayer_status) {
			if (rc & 1) {
				erase_file("dumpsub.jss");
			}
			if (rc & 2) {
				erase_file("audiodump.wav");
			}
			Info("Mplayer","Błąd wykonania mplayera");
			if (subname) {
				g_free(subname);
			}
			enable_video_menues(-1,NULL);
			return;
		}
	}
	
	if (subname) {
		g_free(subname);
	}
	fname="dumpsub.jss";
	auto_load_dic=0;
	if (!(rc & 1)) {
		if (sub_exists & 2) {
			fname="dumpsub.txt";
			auto_load_dic= (sub_exists & 4);
		}
	}

	sprintf(buf,"%s/%s",movie_workdir,fname);
	open_file(NULL,g_strdup(buf));
	enable_video_menues(-1,NULL);
}

static struct jacosub {
	int timer;
	//char *text;
        char *pho;
        int orig_msec;
        double speed;
        int real_msec;
        int max_sample;
        int start_sample;
        int num_samples;
        double volmpx;
} *jacos;
static int jacos_count;
static int njacos;
static void jacos_free(void)
{
	int i;
	for (i=0;i<njacos;i++) if (jacos[i].pho) free(jacos[i].pho);
	njacos=0;
}

static int compute_msec(char *c)
{
    int plen=100;
    char *d;
    for (;*c;c=d+1) {
        d=strchr(c,'\n');
        if (!d) break;
        while (*c && isspace(*c) && *c!='\n') c++;
        if (*c==';' || *c=='\n') continue;
        while (*c != '\n' && !isdigit(*c))  c++;
        if (!*c || *c=='\n') continue;
        plen+=strtol(c,&c,10);
    }
    return plen;
}

int make_jacolist(void)
{
	char *str=get_current_iso2();
	char *cs,*nd,*ph;
	int timeres,msec,dura,i,maxmili,devmili;
	if (!jacos_count) {
		jacos=calloc(sizeof(*jacos),jacos_count=1024);
		njacos=0;
	}
	else {
		jacos_free();
	}
	if (!str) return;
	if (strncmp(str,"#TIMERES",8)) {
		free(str);
		return 0;
	}
	timeres=strtol(str+8,&cs,10);
	
	if (!timeres) {
		free(str);
		return 0;
	}
	for (;cs && *cs;) {
		cs+=strspn(cs,"\r\n");
		if (!*cs) break;
		if (!isdigit(*cs)) {
bad_loop:	cs=strpbrk(cs,"\r\n");
			if (!cs) break;
			continue;
		}
		msec=get_jaco_timer(cs,timeres);
		if (msec < 0) goto bad_loop;
		cs+=strspn(cs,"0123456789 .:\t");
		for (;*cs;) {
			cs+=strspn(cs,"\t /-");
			if (*cs != '{') break;
			for (;*cs;) {
				if (strchr("\r\n",*cs)) break;
				if (*cs++=='}') break;
			}
		}
		nd=strpbrk(cs,"\r\n");
		if (!nd) nd=cs+strlen(cs);
		if (nd == cs) continue;
		if (*nd) *nd++=0;
		ph=translate_subtitle(cs);
		cs=nd;
		if (!ph) continue;
		dura=compute_msec(ph);
		if (dura <= 100) continue;
		if (jacos_count <= njacos) {
			jacos_count+=1024;
			jacos=realloc(jacos,sizeof(*jacos) * jacos_count);
		}
		memset(&jacos[njacos],0,sizeof(*jacos));
		jacos[njacos].timer=msec;
		jacos[njacos].pho=strdup(ph);
		jacos[njacos].orig_msec=dura;
		njacos++;
	}
	free(str);
	if (!njacos) return 0;
    maxmili=0;
    for (i=0;i<njacos-1;i++) {
        if (jacos[i].timer + smix_speed * jacos[i].orig_msec <= jacos[i+1].timer) {
            jacos[i].speed=smix_speed;
        }
        else {
            double t=(jacos[i+1].timer - jacos[i].timer)/(double)jacos[i].orig_msec;
            if (t >= smix_maxspeed) {
                jacos[i].speed=t;
            }
            else {
                jacos[i].speed=smix_maxspeed;
            }
        }
        jacos[i].real_msec=jacos[i].orig_msec* jacos[i].speed;
        if (jacos[i].timer + jacos[i].real_msec > jacos[i+1].timer) {
			devmili=(jacos[i].timer+jacos[i].real_msec)-jacos[i+1].timer;
			if (devmili > maxmili) maxmili=devmili;
			jacos[i+1].timer=jacos[i].timer + jacos[i].real_msec;
		}
    }
    jacos[i].speed=smix_speed;
    return maxmili;
}

#ifndef O_BINARY
#define O_BINARY 0
#endif

static int g32(char *buf)
{
	return (buf[0] & 255) |
		((buf[1] & 255) << 8) |
		((buf[2] & 255) <<16) |
		((buf[3] & 255) <<24);
}

static int g16(char *buf)
{
	return (buf[0] & 255) |
		((buf[1] & 255) << 8);
}

static off_t smix_input_wave_start;
static int smix_input_channels;
static int smix_input_samplefreq;
static long smix_input_samples;
static int smix_input_fd,smix_output_fd;
static double smix_volume_mpx;
static int smix_computed_margin;

static int smix_break;
static int mplaudio_percent;

static GtkWidget *mplaudio_dialog,*mplaudio_pgm;
static int smix_break_imm;
static void mplaudio_break(GtkWidget *w,gint id,gpointer udata)
{
	if (id != 100) return;
	if (smix_break_imm) {
		smix_break=1;
		return;
	}
	if (Ask2("Pytanie","Na pewno przerywasz?",mplaudio_dialog)) smix_break=1;
}
static GtkLabel *mplaudio_label;
void show_mplaudio_dialog(char *txt,int imedia)
{
	mplaudio_percent=0;
	smix_break_imm=imedia;
	mplaudio_dialog=gtk_dialog_new_with_buttons("Przetwarzanie",
			(gpointer)main_window,
			GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL,
			"Przerwij",100,NULL);
	g_signal_connect_swapped(G_OBJECT(mplaudio_dialog), "delete-event",
	      G_CALLBACK(rt), NULL);
	g_signal_connect_swapped(G_OBJECT(mplaudio_dialog), "response",
	      G_CALLBACK(mplaudio_break), NULL);

	mplaudio_label=(gpointer)gtk_label_new(txt);
	gtk_label_set_selectable((gpointer)mplaudio_label,TRUE);
	GtkWidget *box=gtk_vbox_new(0,2);
	gtk_box_pack_start(GTK_BOX(box),(gpointer)mplaudio_label,FALSE,FALSE,0);
	mplaudio_pgm=gtk_progress_bar_new();
	gtk_progress_bar_set_bar_style((gpointer)mplaudio_pgm,GTK_PROGRESS_CONTINUOUS);
	gtk_progress_bar_set_orientation((gpointer)mplaudio_pgm,GTK_PROGRESS_LEFT_TO_RIGHT);
	gtk_box_pack_start(GTK_BOX(box),(gpointer)mplaudio_pgm,FALSE,FALSE,0);

	GtkWidget *ca=gtk_dialog_get_content_area (GTK_DIALOG (mplaudio_dialog));
	gtk_container_add (GTK_CONTAINER (ca), box);
	gtk_widget_set_size_request((gpointer)mplaudio_pgm, 320,-1);
	gtk_widget_show_all(mplaudio_dialog);
	

}
void hide_mplaudio_dialog(void)
{
	if (mplaudio_dialog) {
		gtk_widget_hide_all((gpointer) mplaudio_dialog);
		gtk_widget_destroy(mplaudio_dialog);
		mplaudio_dialog=NULL;
	}
}
void show_mplaudio_percent(double pc)
{
	int ipc=pc*100.0;
	if (ipc>100) ipc=100;
	else if (ipc<0) ipc=0;
	if (ipc == mplaudio_percent) return;mplaudio_percent=ipc;
	gtk_progress_bar_set_fraction((gpointer)mplaudio_pgm,ipc/100.0);
}

void show_mplaudio_label(char *txt)
{
	gtk_label_set_text((gpointer)mplaudio_label,txt);
	yield();
}

static int compute_max_sample(int fra,int nsamples,int interact)
{
	long startpos=2*smix_input_channels*fra;
	size_t n;
    int mx,tlen;
	int buflen=1048576;
    static short *lbuffer;
    if (!lbuffer) lbuffer=malloc(2*buflen);
    if (startpos<0) startpos=0;
	if (fra+nsamples > smix_input_samples) nsamples=smix_input_samples-fra;
	n=nsamples*smix_input_channels;
	lseek(smix_input_fd,startpos+smix_input_wave_start,SEEK_SET);
	mx=0;
	tlen=n;
	while (n>0) {
		int p=1048576,r,i;
		if (p>2*n) p=2*n;
		r=read(smix_input_fd,lbuffer,p);
		if (r<=0) {
              if (interact) hide_mplaudio_dialog();
              Error("Odczyt",strerror(errno));
              return -1;
        }
		r=r/2;
		for (i=0;i<r;i++) {
			if (lbuffer[i]<0) {
				if (lbuffer[i]<-mx) mx=-lbuffer[i];
			}
			else {
				if (lbuffer[i]>mx) mx=lbuffer[i];
			}
		}
		n-=r;
		if (interact) show_mplaudio_percent((double)(tlen-n)/(double)tlen);
		yield();
		if (smix_break) {
			mx=-1;
			break;
		}
	}
	return mx;
}

int open_input_wave(char *name)
{
	int fd=open(name,O_RDONLY | O_BINARY);
	int wlen,nsamples,max_sample;
	char buf[1024];
	if (fd<0) {
dupa:
		sprintf(buf,"Błąd pliku audiodump.wav:\n%s",strerror(errno));
		Error("Błąd",buf);
dupa2:		if (fd >= 0) close(fd);
		return 0;
	}
	if (read(fd,buf,20)!=20) goto dupa;
	if (memcmp(buf,"RIFF",4)) {
		Error("Błąd audiodump","To nie jest plik RIFF");
		goto dupa2;
	}
	if (memcmp(buf+8,"WAVE",4)) {
		Error("Błąd audiodump","To nie jest plik WAV");
		goto dupa2;
	}
	if (memcmp(buf+12,"fmt ",4)) {
kop:	Error("Błąd audiodump","Błędny plik WAV");
		goto dupa2;
	}
	wlen=g32(buf+16);
	if (wlen<12 || wlen > 64) goto kop;
	if (read(fd,buf,wlen)!=wlen) goto dupa;
	if (g16(buf) != 1) {
		Error("Błąd audiodump","To nie jest PCM WAV");
		goto dupa2;
	}
	smix_input_channels=g16(buf+2);
	if (smix_input_channels != 1 && smix_input_channels != 2) {
		Error("Błąd audiodump","To nie jest PCM MONO/STEREO\n");
		goto dupa2;
	}
	smix_input_samplefreq=g32(buf+4);
	if (g16(buf+12) != 2*smix_input_channels) {
		Error("Błąd audiodump","To nie jest PCM 16bit");
		goto dupa2;
	}
	if (read(fd,buf,8)!=8) goto dupa;
	if (memcmp(buf,"data",4)) goto kop;
	wlen=g32(buf+4);
	smix_input_samples=wlen/(2*smix_input_channels);
	smix_input_wave_start=lseek(fd,0,SEEK_CUR);
	smix_input_fd=fd;
	smix_computed_margin=(smix_input_samplefreq * smix_audio_margin)/1000;
	max_sample=compute_max_sample(0,smix_input_samples,1);
	if (max_sample <= 0) {
		close(fd);
		return 0;
	}
    smix_volume_mpx=(32767*smix_volume_factor)/(max_sample * (1.0+smix_volume_factor));
	return 1;
}

static int plan_lastpos=0;
#define PLAN_VOL_NORMAL 0
#define PLAN_VOL_FADE 1
#define PLAN_VOL_MIX 2

static struct planen {
    int plan;
    double vol1;
    double vol2;
    int duration;
    int jaco;
} *plany;

static int plany_cnt,plany_size;

void add_plan(int plan,double vol1, double vol2,int duration,int mix)
{
    if (!plany_size) {
        plany_size=1024;
        plany=malloc(plany_size * sizeof(*plany));
    }
    else if (plany_cnt >= plany_size) {
        plany_size+=1024;
        plany=realloc(plany,plany_size * sizeof(*plany));
    }
    plany[plany_cnt].plan=plan;
    plany[plany_cnt].vol1=vol1;
    plany[plany_cnt].vol2=vol2;
    plany[plany_cnt].duration=duration;
    plany[plany_cnt].jaco=mix;
    plany_cnt++;
    plan_lastpos+=duration;
    //printf("%d %.3f %.3f %04d %d\n",plan,vol1,vol2,mix,duration);
}


static int init_plan(void)
{
	int i;
    for (i=0;i<njacos;i++) {
        double vmp;
        jacos[i].start_sample=(jacos[i].timer * (double)smix_input_samplefreq)/1000;
        jacos[i].num_samples=(jacos[i].real_msec * (double)smix_input_samplefreq)/1000;
        jacos[i].max_sample=compute_max_sample(jacos[i].start_sample-smix_computed_margin,jacos[i].num_samples+2*smix_computed_margin,0);
        if (jacos[i].max_sample<100) jacos[i].volmpx=smix_volume_mpx*smix_max_origin_vol;
        else {
            vmp=(32767.0/(1.0+smix_volume_factor)) / jacos[i].max_sample;
            if (vmp > smix_volume_mpx*smix_max_origin_vol) vmp=smix_volume_mpx*smix_max_origin_vol;
            jacos[i].volmpx=vmp;
        }
    }
    for (i=njacos-2;i>=0;i--) {
        if (jacos[i].timer+jacos[i].real_msec > jacos[i+1].timer-500) jacos[i].volmpx=jacos[i+1].volmpx;
    }
	double lastvol=smix_volume_mpx;
    int rise_d=((double)smix_risetime * (double)smix_input_samplefreq)/1000;
    int drop_d=((double)smix_droptime * (double)smix_input_samplefreq)/1000;
    int mini_d=rise_d + drop_d + (smix_mindist * (double)smix_input_samplefreq)/1000;
    int nstart;
    plany_cnt=0;plan_lastpos=0;
    
    for (i=0;i<njacos;i++) {
		show_mplaudio_percent((double)i/(double)njacos);
		yield();
		if (smix_break) return 0; 
        if (!i) {
            if (jacos[i].start_sample > drop_d) {
                add_plan(PLAN_VOL_NORMAL,smix_volume_mpx*smix_max_origin_vol,0.0,jacos[i].start_sample-drop_d,0);
                add_plan(PLAN_VOL_FADE,smix_volume_mpx*smix_max_origin_vol,jacos[i].volmpx,drop_d,0);
            }
            else {
                add_plan(PLAN_VOL_NORMAL,jacos[i].volmpx,0.0,drop_d,0);
            }
        }
        else {
            nstart=jacos[i].start_sample-plan_lastpos;
            if (nstart >= mini_d) {
                add_plan(PLAN_VOL_FADE,lastvol,smix_volume_mpx*smix_max_origin_vol,rise_d,0);
                add_plan(PLAN_VOL_NORMAL,smix_volume_mpx*smix_max_origin_vol,0.0,nstart- (rise_d + drop_d),0);
                add_plan(PLAN_VOL_FADE,smix_volume_mpx*smix_max_origin_vol,jacos[i].volmpx,drop_d,0);
            }
            else if (nstart) {
                add_plan(PLAN_VOL_FADE,lastvol,jacos[i].volmpx,nstart,0);
            }
        }
        add_plan(PLAN_VOL_MIX,jacos[i].volmpx,smix_volume_factor/(1.0+smix_volume_factor),jacos[i].num_samples,i);
        lastvol=jacos[i].volmpx;
    }
    nstart=smix_input_samples-plan_lastpos;
    if (nstart > rise_d) {
        add_plan(PLAN_VOL_FADE,lastvol,smix_volume_mpx*smix_max_origin_vol,rise_d,0);
        add_plan(PLAN_VOL_NORMAL,smix_volume_mpx*smix_max_origin_vol,0.0,nstart-rise_d,0);
    }
    else if (nstart>0) {
        add_plan(PLAN_VOL_NORMAL,lastvol,0.0,nstart,0);
    }
	return 1;
}


static void mbrola_fk(int *to_mbr,int *from_mbr,double tempo,double pitch)
{
	char b1[32],b2[32];
	close(to_mbr[1]);
	close(from_mbr[0]);
	dup2(to_mbr[0],0);
	dup2(from_mbr[1],1);
	sprintf(b1,"%.2f",tempo);
	sprintf(b2,"%.2f",pitch);
	
	execlp("mbrola","mbrola","-f",b2,"-t",b1,"-e",mbrola_voice,"-","-",NULL);
	exit(1);
}

static char *wavebuffer;
static int wavebuflen; 
static int wave_size;
static int milena_wave_pos,milena_wave_len;
static short *milena_wave_buffer;
static float resample_input[4096];
static float resample_buffer[4096];
static short resample_output[4096];
static int resample_count;
static int resample_pos;

static int make_wave(char *pho,double tempo,double pitch)
{
	int from_mbr[2],to_mbr[2],pid,i,imx;
	char buffer[4096];
	pipe(to_mbr);
	pipe(from_mbr);
	pid=fork();
	if (pid<0) {
		close(to_mbr[0]);
		close(to_mbr[1]);
		close(from_mbr[0]);
		close(from_mbr[1]);
		return -1;
	}
	if (!pid) mbrola_fk(to_mbr,from_mbr,tempo,pitch);
	close(to_mbr[0]);
	close(from_mbr[1]);
	write(to_mbr[1],pho,strlen(pho));
	write(to_mbr[1],"_ 50\n",5);
	close(to_mbr[1]);
	wave_size=0;
	for (;;) {
		int n=read(from_mbr[0],buffer,4096);
		if (n<=0) break;
		if (!wavebuflen) {
			wavebuffer=malloc(wavebuflen=65536);
		}
		else if (wavebuflen < n+wave_size) {
			wavebuflen+=65536;
			wavebuffer=realloc(wavebuffer,wavebuflen);
		}
		memcpy(wavebuffer+wave_size,buffer,n);
		wave_size+=n;
	}
	resample_count=0;
	resample_pos=0;
	close(from_mbr[0]);
	waitpid(pid,NULL,0);
	if (!wave_size) return -2;
	milena_wave_buffer=(short *)wavebuffer;
	milena_wave_len=wave_size/2;
	if (contrast) do_contrast(milena_wave_buffer,milena_wave_len);
	imx=0;
    for (i=0;i<milena_wave_len;i++) {
        if (milena_wave_buffer[i] > imx) imx=milena_wave_buffer[i];
        else if (-milena_wave_buffer[i] > imx) imx=-milena_wave_buffer[i];
    }
    if (!imx) {
        milena_wave_len=0;
        return 0;
    }
    if (imx < 32767) {
        double mpx=32767.0/(double) imx;
        for (i=0;i<milena_wave_len;i++) milena_wave_buffer[i]=milena_wave_buffer[i]*mpx;
    }
	
	return 0;
}

static int create_milena_wave(int n)
{
	struct jacosub *jaco=&jacos[n];
	make_wave(jaco->pho,jaco->speed,gtk_spin_button_get_value((gpointer)spin_pitch));
	milena_wave_pos=0;
	//printf("Kwestgia %d len %d\n",n,milena_wave_len);
	return 1;
}


static SRC_STATE *resampler;
static SRC_DATA res_data;

static int resample_data(void)
{
    static int resampler_error;
    int nm;
    char buf[1024];
    if (!resampler) {
        resampler=src_new (SRC_SINC_MEDIUM_QUALITY, 1, &resampler_error) ;
        if (!resampler) {
            sprintf(buf,"Resampler zdechł, numer błędu %d\n",resampler_error);
            Error("Błąd",buf);
            return 0;
        }
        res_data.src_ratio=smix_input_samplefreq/16000.0;
        res_data.data_out=resample_buffer;
        res_data.data_in=resample_input;
    }
    if (!milena_wave_pos) src_reset(resampler);
    nm=milena_wave_len-milena_wave_pos;
    if (nm > 4096) nm=4096;
    res_data.end_of_input=0;
    if (nm<=0) {
        res_data.end_of_input=1;
        nm=0;
    }
    src_short_to_float_array(milena_wave_buffer+milena_wave_pos,resample_input,nm);
    res_data.input_frames=nm;
    res_data.output_frames=4096;
    int er=src_process(resampler,&res_data);
	//printf("ER %d %s\n%d %d/%d\n",er,src_strerror(er),
	//	nm,res_data.output_frames_gen,res_data.input_frames_used);
	resample_count=res_data.output_frames_gen;
    src_float_to_short_array(resample_buffer,resample_output,resample_count);
    resample_pos=0;
    //printf("Resampler at %d-%d(%d) - %d,%d\n",
	//	milena_wave_pos,milena_wave_len,
	//	res_data.input_frames_used,
	//	resample_count,nm);
    milena_wave_pos+=res_data.input_frames_used;
    if (!nm && !resample_count) milena_wave_pos++;
	return 1;
}

static int milena_get_sample(short *sample)
{
    if (milena_wave_pos > milena_wave_len) {
        *sample=0;
        return 0;
    }
    if (resample_pos >= resample_count) {
        if (!resample_data()) return -1;
		if (milena_wave_pos > milena_wave_len) {
			*sample=0;
			return 0;
		}   
    }
    *sample=resample_output[resample_pos++];
    return 1;
}

#define IN_BUFFER_SIZE 1048576
#define OU_BUFFER_SIZE 1048576

static short input_buffer[IN_BUFFER_SIZE];
static short output_buffer[OU_BUFFER_SIZE];
static int buffer_pos,buffer_len;
static int outbuf_pos;
static short sample_L,sample_R,milena_sample;

static int get_sample(void)
{
    if (buffer_pos >= buffer_len) {
        int n=read(smix_input_fd,(char *)input_buffer,IN_BUFFER_SIZE);
        if (n<=0) return 0;
        buffer_pos=0;
        buffer_len=n/2;
    }
    if (buffer_pos < buffer_len) {
        sample_L=input_buffer[buffer_pos++];
        if (smix_input_channels == 2) sample_R=input_buffer[buffer_pos++];
    }
    return 1;
}
static int output_fd_pos;
static int put_sample(void)
{
    output_buffer[outbuf_pos++]=sample_L;
    if (smix_input_channels == 2) output_buffer[outbuf_pos++]=sample_R;
    if (outbuf_pos>=(OU_BUFFER_SIZE/2)) {
        int n=write(smix_output_fd,output_buffer,outbuf_pos*2);
        if (n!= 2* outbuf_pos) {
            Error("Błąd",strerror(errno));
            return 0;
        }
        output_fd_pos+=outbuf_pos/smix_input_channels;
        show_mplaudio_percent((double)output_fd_pos/(double)smix_input_samples);
        yield();
        outbuf_pos=0;
    }
    return 1;
}



static void multiply_sample(double mpx)
{
    sample_L *= mpx;
    sample_R *= mpx;
}

static int add_milena_sample(double mpx)
{
    int n;
    n=milena_get_sample(&milena_sample);
	if (!n) return 1;
    if (n<0) return 0;
    n=milena_sample * mpx;
    sample_L += n;
    sample_R += n;
    return 1;
}

static int realizer_d;

int realize_plan(struct planen *plan)
{
    int i;
    //show_mplaudio_percent((double)realizer_d/(double)smix_input_samples);
	yield();
	if (smix_break) return 0;
    realizer_d+=plan->duration;
    if (plan->plan == PLAN_VOL_MIX) {
        create_milena_wave(plan->jaco);
    }
    for (i=0;i<plan->duration;i++) {
        if (!get_sample()) return 0;
        switch(plan->plan) {
            case PLAN_VOL_NORMAL:
                multiply_sample(plan->vol1);
                break;
            case PLAN_VOL_FADE:
                multiply_sample(plan->vol1 + ((plan->vol2-plan->vol1) * i)/plan->duration);
                break;
            default:
                multiply_sample(plan->vol1);
                add_milena_sample(plan->vol2);
        }
        put_sample();
        if (smix_break) {
			return 0;
		}
    }
    //if (plan->plan == PLAN_VOL_MIX) {
    //   free_milena_wave();
    //}
    return 1;
}


static int start_planer(char *outname)
{
    char buf[1024];
    smix_output_fd=open(outname,O_WRONLY | O_CREAT | O_TRUNC, 0644);
    if (smix_output_fd < 0) {
        Error("Błąd",strerror(errno));
        return 0;
    }
    lseek(smix_input_fd,0,SEEK_SET);
    read(smix_input_fd,buf,smix_input_wave_start);
    write(smix_output_fd,buf,smix_input_wave_start);
    show_mplaudio_label("Realizacja");
    show_mplaudio_percent(0.0);
    realizer_d=0;
    return 1;
}

int finish_planer(void)
{
    if (outbuf_pos>0) {
        int n=write(smix_output_fd,output_buffer,outbuf_pos*2);
        if (n!= 2* outbuf_pos) {
            Error("Błąd",strerror(errno));
            return 0;
        }
    }
    close(smix_output_fd);
    return 1;
}

static void fine_mpla(void)
{
	char buf[1024];
	if (smix_input_fd>=0) {
		close(smix_input_fd);
		smix_input_fd=-1;
	}
	if (smix_output_fd>=0) {
		close(smix_output_fd);
		smix_output_fd=-1;
		sprintf(buf,"%s/newaudio.wav",movie_workdir);
		unlink(buf);
	}
	if (resampler) {
		src_delete(resampler);
		resampler=NULL;
	}
	hide_mplaudio_dialog();
	close_milena_libs();
	enable_video_menues(-1,NULL);
}

void mplayer_make_audio(GtkWidget *widget, void *dummy)
{
	char buf[256];int mdel,i;
	if (!init_milena_libs(0)) return;
	init_paragraph();
	smix_input_fd=-1;
	smix_output_fd=-1;
	start_busy_cursor();
	yield();
	mdel=make_jacolist();
	end_busy_cursor();
	if (!njacos) {
		Error("Błąd","Nie utworzono zni jednej kwestii");
		close_milena_libs();
		return;
	}
	sprintf(buf,"Ilość kwestii: %d\nMaksymalne opóźnienie: %d msec",
		njacos,mdel);
	if (!Ask("Pytanie",buf)) {
		close_milena_libs();
		return;
	}
	smix_break=0;
	sprintf(buf,"%s/audiodump.wav",movie_workdir);
	show_mplaudio_dialog("Normalizuję oryginał",0);
	yield();
	if (!open_input_wave(buf)) {
		fine_mpla();
		return;
	}
	show_mplaudio_label("Inicjalizuję plan");
	if (!init_plan()) {
		fine_mpla();
		return;
	};
	sprintf(buf,"%s/newaudio.wav",movie_workdir);
	if (!start_planer(buf)) {
		fine_mpla();
		return;
	}
	yield();
	for (i=0;i<plany_cnt;i++) {
		yield();
		if (smix_break) {
			fine_mpla();
			return;
		}
		if (!realize_plan(&plany[i])) {
			fine_mpla();
			return;
		}
	}
	if (!finish_planer()) {
		fine_mpla();
		return;
	}
	close(smix_output_fd);
	smix_output_fd=-1;
	fine_mpla();
	Info("Informacja","Przetwarzanie zakończone");
}



static int run_mencoder(char *fname)
{
	char *mencs[32];
	char buforek[1024];
	int ve;
	int pipa[2];
	int pid;
	FILE *f;
	pipe(pipa);
	pid=fork();
	if (pid < 0) {
		Error("Błąd",strerror(errno));
		return -1;
	}
	if (!pid) {
		close(0);
		close(2);
		close(pipa[0]);
		dup2(pipa[1],1);
		mencs[0]="mencoder";
		ve=1;
		mencs[ve++]="-audiofile";
		sprintf(buforek,"%s/newaudio.wav",movie_workdir);
		mencs[ve++]=buforek;
		mencs[ve++]="-ovc",
		mencs[ve++]="copy";
		mencs[ve++]="-oac";
		mencs[ve++]="mp3lame";
		mencs[ve++]="-o";
		mencs[ve++]=fname;
		mencs[ve++]=movie_name;
		mencs[ve++]=NULL;
		execvp(mencs[0],mencs);
		exit(1);
	}
	close(pipa[1]);
	f=fdopen(pipa[0],"r");
	int lpc=-1;
	int lmi=-1;
	smix_break=0;
	show_mplaudio_dialog("Tworzę film wynikowy",1);
	while(fgets(buforek,256,f)) {
		yield();
		if (smix_break) {
			kill(pid,9);
			break;
		}
		char *c=strstr(buforek,"Pos:");
		if (!c) continue;
		c=strchr(c,'(');
		if (!c) continue;
		while (*c && !isdigit(*c)) c++;
		if (!*c) continue;
		int perc=strtol(c,&c,10);
		if (*c++!='%') continue;
		c=strstr(c,"Trem:");
		if (!c) continue;
		while (*c && !isdigit(*c)) c++;
		if (!*c) continue;
		int mins=strtol(c,&c,10);
		if (perc != lpc) {
			lpc=perc;
			show_mplaudio_percent(perc/100.0);
		}
	}
	waitpid(pid,NULL,0);
	fclose(f);
	hide_mplaudio_dialog();
	if (smix_break) {
		Error("Przerwanie","Mencoder przerwany");
	}
	else {
		Info("Informacja","Film został utworzony");
	}
	
}

		

void mplayer_make_video(GtkWidget *widget, void *dummy)
{
	int n;
	char path[1024];
	GtkWidget *dialog=gtk_file_chooser_dialog_new(
		"Wybierz plik do zapisu filmu",
		GTK_WINDOW(main_window),GTK_FILE_CHOOSER_ACTION_SAVE,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
		NULL);
	GtkFileFilter *filter;
	gtk_file_chooser_set_local_only((gpointer)dialog,TRUE);
	gtk_file_chooser_add_filter((gpointer) dialog,
		filter=make_filter("Pliki AVI","*.avi","*.AVI",NULL));
	gtk_file_chooser_add_filter((gpointer) dialog,
		make_filter("Wszystkie pliki","*",NULL));
	gtk_file_chooser_set_filter((gpointer) dialog,filter);
	
	gtk_file_chooser_set_do_overwrite_confirmation((gpointer)dialog,TRUE);
#if GTK_CHECK_VERSION(2,18,0)
	gtk_file_chooser_set_create_folders((gpointer)dialog,TRUE);
#endif
	if ((n=gtk_dialog_run((gpointer)dialog))==GTK_RESPONSE_ACCEPT){
		strcpy(path,gtk_file_chooser_get_filename((gpointer)dialog));
	}
	gtk_widget_destroy(dialog);
	if (n==GTK_RESPONSE_ACCEPT) {
		run_mencoder(path);
	}
}

void mplayer_settings(GtkWidget *widget, void *dummy)
{
	int rc;
	GtkWidget *dialog=gtk_dialog_new_with_buttons("Ustawienia lektora",
			(gpointer)main_window,
			GTK_DIALOG_DESTROY_WITH_PARENT,
			GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL,
			GTK_STOCK_OK,GTK_RESPONSE_OK,NULL);
	GtkWidget *ca=gtk_dialog_get_content_area (GTK_DIALOG (dialog));

	GtkWidget *vbox=gtk_vbox_new(0,2);
	GtkWidget *stable=gtk_table_new(2,2,0);
	GtkWidget *label;

	label=gtk_label_new("Tempo normalne");
	gtk_table_attach_defaults((gpointer)stable,label,0,1,0,1);
	GtkWidget *w_tempo=gtk_spin_button_new_with_range(0.5,1.5,0.01);
	gtk_table_attach_defaults((gpointer)stable,w_tempo,1,2,0,1);
	gtk_spin_button_set_value((gpointer)w_tempo,smix_speed);
	connect_label(label,w_tempo);
	
	label=gtk_label_new("Tempo maksymalne");
	gtk_table_attach_defaults((gpointer)stable,label,0,1,1,2);
	GtkWidget *w_tempo2=gtk_spin_button_new_with_range(0.5,1.5,0.01);
	gtk_table_attach_defaults((gpointer)stable,w_tempo2,1,2,1,2);
	gtk_spin_button_set_value((gpointer)w_tempo2,smix_maxspeed);
	connect_label(label,w_tempo2);
	
	label=gtk_label_new("Stosunek lektor/podkład");
	gtk_table_attach_defaults((gpointer)stable,label,0,1,2,3);
	GtkWidget *w_fact=gtk_spin_button_new_with_range(2.0,8.0,0.1);
	gtk_table_attach_defaults((gpointer)stable,w_fact,1,2,2,3);
	gtk_spin_button_set_value((gpointer)w_fact,smix_volume_factor);
	connect_label(label,w_fact);

	label=gtk_label_new("Max. głośność oryginału");
	gtk_table_attach_defaults((gpointer)stable,label,0,1,3,4);
	GtkWidget *w_fvol=gtk_spin_button_new_with_range(0.5,1.0,0.05);
	gtk_table_attach_defaults((gpointer)stable,w_fvol,1,2,3,4);
	gtk_spin_button_set_value((gpointer)w_fvol,smix_max_origin_vol);
	connect_label(label,w_fvol);
	
	gtk_box_pack_start(GTK_BOX(vbox),stable,FALSE,FALSE,0);
	
	gtk_container_add (GTK_CONTAINER (ca), vbox);
	
	gtk_widget_show_all(dialog);
	for (;;) {
		double s1,s2,fa,vo; 
		rc=gtk_dialog_run(GTK_DIALOG(dialog));
		if (rc != GTK_RESPONSE_OK) {
			gtk_widget_destroy(dialog);
			return;
		}
		s1=gtk_spin_button_get_value((gpointer)w_tempo);
		s2=gtk_spin_button_get_value((gpointer)w_tempo2);
		if (s1 < s2-0.001) {
			Error("Błąd","Wartość w polu \"tempo maksymalne\"\nnie może być wyższa\nod wartości w polu \"Tempo normalne\"");
			continue; 
		}
		if (s2 > s1) s2=s1;
		smix_speed=s1;
		smix_maxspeed=s2;
		smix_volume_factor=fa;
		smix_max_origin_vol=vo;
		gtk_widget_destroy(dialog);
		break;
	}
	return;
}

